﻿using UnityEngine;
using UnityEngine.UI;
using System.Collections.Generic;
using UnityEngine.SceneManagement;

public class GameManager : MonoBehaviour
{
    public static GameManager Instance;

    public GameObject[] randomPeople;

    public int currentLives;
    public int waveTarget;
    public int currentWaves;
    public float gameEndTime;
	public float nextDamage;
	public bool gameOn;

    public GameObject buttonPrefab;

	public List<GameObject> activeCops = new List<GameObject> ();

    public MainUI mainUi;
	public GameObject gameUIObject;
	public GameObject winPanel;
	public GameObject losePanel;

	public AudioSource music;
	public AudioSource crash;
	public AudioSource land;
	public AudioSource[] turn;
	public AudioSource[] point;
	public AudioSource copAmbience;
	public AudioSource engineUp;
	public AudioSource engineDown;
	public AudioSource engineFull;
	public AudioSource engineIdle;
	public AudioSource sadPope;
	public AudioSource boo;
	public AudioSource scream;

	public void Awake ()
	{
		Instance = this;
		waveTarget = 75;
	}

	public void Start ()
	{
		StartLevel ();
	}

	public void StartLevel ()
	{
		gameOn = true;
		ShowGameUI();
		waveTarget = 125;
		currentWaves = 0;
		currentLives = 5;
		gameEndTime = Time.time + 210f;
		/*mainUi.ClearHearts();
		for(int i = 0; i < 5; i++)
		{
			mainUi.AddHeart();
		}*/
	}

    public void ShowGameUI ()
    {
        gameUIObject.SetActive (true);
        winPanel.SetActive (false);
		losePanel.SetActive (false);
    }

	public void PauseGame ()
	{
		gameOn = false;
	}

	public void UnpauseGame () //Incomplete!
	{
		gameOn = true;
	}

	public void LoseLife (bool hitPerson)
	{
		if (Time.time > nextDamage)
		{
			if (hitPerson)
				sadPope.Play ();
			else
				crash.Play ();
			
			currentLives--;
			mainUi.RemoveHeart();
			if(currentLives < 1 && gameOn)
			{
				OnPlayerLose();
			}
			nextDamage = Time.time + 1.5f;
		}
	}

	public void GainLife () //Can't visually add hearts yet
	{
		currentLives++;
		//mainUi.AddHeart();
	}

	public void WaveAtPerson (GameObject person)
	{
		currentWaves++;
		point [Random.Range (0, point.Length)].Play ();
		GameObject newPerson = GameObject.Instantiate(randomPeople[UnityEngine.Random.Range(0, randomPeople.Length)], person.transform.position, person.transform.rotation);
		GameObject.Destroy(person);
		Person p = newPerson.GetComponent<Person>();
		p.HasBeenWavedTo = true;
		if(currentWaves >= waveTarget && gameOn)
		{
			OnPlayerWin();
		}
	}

    public void OnPlayerLose ()
    {
		PauseGame ();
		losePanel.SetActive (true);
		boo.Play ();
		music.Stop ();
    }

    public void OnPlayerWin ()
    {
		PauseGame ();
		winPanel.SetActive (true);
		music.Stop ();
    }

	public void LoadScene (int indx)
	{
		SceneManager.LoadScene (indx);
	}
}